Index: libabac/abac.c
===================================================================
--- libabac/abac.c	(revision d4b3b529e2089c1d6789e5f0d05d99ff3aa4c533)
+++ libabac/abac.c	(revision c75b2c28006e67279531bed747ab66b8aa312373)
@@ -1,7 +1,7 @@
+/* abac.c */
+
 #include <assert.h>
 #include <err.h>
 #include <glob.h>
-
-#include <chunk.h>
 
 #include "abac.h"
@@ -80,7 +80,6 @@
  * Load an ID cert from a chunk.
  */
-int abac_context_load_id_chunk(abac_context_t *ctx, abac_chunk_t cert) {
-    assert(ctx != NULL);
-    chunk_t cert_chunk = { cert.ptr, cert.len };
+int abac_context_load_id_chunk(abac_context_t *ctx, abac_chunk_t cert_chunk) {
+    assert(ctx != NULL);
     return abac_verifier_load_id_chunk(cert_chunk);
 }
@@ -91,15 +90,22 @@
 int abac_context_load_attribute_file(abac_context_t *ctx, char *filename) {
     int ret, add_ret;
+    abac_list_t *cred_list=abac_list_new(); // could be more than 1
     abac_credential_t *cred;
 
     assert(ctx != NULL); assert(filename != NULL);
 
-    ret = abac_verifier_load_attribute_cert_file(filename, &cred);
+    ret = abac_verifier_load_attribute_cert_file(filename, cred_list);
+
     if (ret == ABAC_CERT_SUCCESS) {
-        add_ret = abac_graph_add_credential(ctx->graph, cred);
-        assert(add_ret != ABAC_GRAPH_CRED_INVALID);
-        abac_credential_free(cred);
-    }
-
+        int size = abac_list_size(cred_list);
+        if(size) {
+            abac_list_foreach(cred_list, cred,
+                add_ret = abac_graph_add_credential(ctx->graph, cred);
+                assert(add_ret != ABAC_GRAPH_CRED_INVALID);
+                abac_credential_free(cred);
+            );
+            abac_list_free(cred_list);
+        }
+    }
     return ret;
 }
@@ -108,17 +114,22 @@
  * Load an attribute cert from a chunk.
  */
-int abac_context_load_attribute_chunk(abac_context_t *ctx, abac_chunk_t cert) {
+int abac_context_load_attribute_chunk(abac_context_t *ctx, abac_chunk_t cert_chunk) {
     int ret, add_ret;
+    abac_list_t  *cred_list=NULL;
     abac_credential_t *cred;
 
     assert(ctx != NULL);
 
-    chunk_t cert_chunk = { cert.ptr, cert.len };
-
-    ret = abac_verifier_load_attribute_cert_chunk(cert_chunk, &cred);
+    ret = abac_verifier_load_attribute_cert_chunk(cert_chunk, cred_list);
     if (ret == ABAC_CERT_SUCCESS) {
-        add_ret = abac_graph_add_credential(ctx->graph, cred);
-        assert(add_ret != ABAC_GRAPH_CRED_INVALID);
-        abac_credential_free(cred);
+        int size = abac_list_size(cred_list);
+        if(size) {
+            abac_list_foreach(cred_list, cred,
+                add_ret = abac_graph_add_credential(ctx->graph, cred);
+                assert(add_ret != ABAC_GRAPH_CRED_INVALID);
+                abac_credential_free(cred);
+            );
+            abac_list_free(cred_list);
+        }
     }
 
@@ -127,5 +138,5 @@
 
 #define ID_PAT "/*_ID.{der,pem}"
-#define ATTR_PAT "/*_attr.der"
+#define ATTR_PAT "/*_attr.xml"
 
 /**
Index: libabac/abac.h
===================================================================
--- libabac/abac.h	(revision d4b3b529e2089c1d6789e5f0d05d99ff3aa4c533)
+++ libabac/abac.h	(revision c75b2c28006e67279531bed747ab66b8aa312373)
@@ -2,9 +2,19 @@
 #define __ABAC_H__
 
-#include <abac_common.h>
+#include <time.h>  // for struct tm 
+#include <stdio.h> // for FILE
+#include "abac_list.h"
 
 typedef struct _abac_context_t abac_context_t;
 typedef struct _abac_credential_t abac_credential_t;
 typedef struct _abac_role_t abac_role_t;
+
+typedef struct _abac_id_t abac_id_t;
+typedef struct _abac_attribute_t abac_attribute_t;
+
+typedef struct _abac_chunk_t {
+    unsigned char *ptr;
+    int len;
+} abac_chunk_t;
 
 /*
@@ -69,4 +79,148 @@
 
 /*
+ * Operations on ID
+ */
+// create an ID from an X.509 certificate
+abac_id_t *abac_id_from_file(char *);
+
+// create an ID from a X.509 certificate PEM chunk
+abac_id_t *abac_id_from_chunk(abac_chunk_t chunk);
+
+// load an X.509 private key from a file
+int abac_id_privkey_from_file(abac_id_t *id, char *filename);
+
+// generate an ID
+// returns one of ABAC_SUCCESS or ABAC_GENERATE_* (see top)
+int abac_id_generate(abac_id_t **ret, char *cn, long validity);
+
+// get the SHA1 keyid, pointer is valid for the lifetime of the object
+char *abac_id_keyid(abac_id_t *id);
+
+// get the name of the issuer
+// caller must free the returned string
+char *abac_id_issuer(abac_id_t *id);
+
+// get the DN of the subject
+// caller must free the returned string
+char *abac_id_subject(abac_id_t *id);
+
+// check if the cert is still valid
+int abac_id_still_valid(abac_id_t *id);
+
+// check if the principal cert's keyid is specified
+int abac_id_has_keyid(abac_id_t *id, char *);
+
+// check if the cert is has a private key
+int abac_id_has_privkey(abac_id_t *id);
+
+// get the validity period of the cert
+int abac_id_validity(abac_id_t *id, struct tm *not_before, struct tm *not_after);
+
+// default filename for the cert: ${CN}_ID.pem
+// caller must free the returned string
+char *abac_id_cert_filename(abac_id_t *id);
+
+// write the cert fo an open file pointer
+int abac_id_write_cert(abac_id_t *id, FILE *out);
+
+// default filename for the private key: ${CN}_key.pem
+// caller must free the return value
+char *abac_id_privkey_filename(abac_id_t *id);
+
+// write the private key to a file
+// it is recommended that you open this file mode 0600
+// returns false if there's no private key loaded
+int abac_id_write_privkey(abac_id_t *id, FILE *out);
+
+// get a chunk representing the cert
+// you must free the ptr of the chunk when done
+abac_chunk_t abac_id_cert_chunk(abac_id_t *id);
+
+// dup an ID (increases its refcount)
+abac_id_t *abac_id_dup(abac_id_t *id);
+
+// destroy the id
+// decreases refcount and destroys when it hits 0
+void abac_id_free(abac_id_t *id);
+
+/*
+ * Operations on Attribute
+ */
+//
+// Here's the skinny:
+//  Attribute cert objects don't contain an actual cert until they're baked.
+//  First you construct the object using abac_attribute_create, then you add
+//  subjects to it using abac_attribute_{principal,role,linking_role}.
+//  Finally you bake it. Once you've done that, you can keep it as XML chunk
+//  or write it to a file.
+//
+
+// create an attribute cert
+// validity is in days
+// returns one of CREDDY_SUCCESS or CREDDY_ATTRIBUTE_* (see top)
+int abac_attribute_create(abac_attribute_t **attr, abac_id_t *issuer, char *role, long validity);
+
+// add a head string to the cert
+void abac_attribute_set_head(abac_attribute_t *attr, char *string);
+
+// return the head string of the attribute
+char *abac_attribute_get_head(abac_attribute_t *);
+
+// add a tail role string to the cert
+void abac_attribute_set_tail(abac_attribute_t *attr, char *string);
+
+// return the tail string of the attribute
+char *abac_attribute_get_tail(abac_attribute_t *);
+
+// add a principal subject to the cert
+int abac_attribute_principal(abac_attribute_t *attr, char *keyid);
+
+// add a role subject
+int abac_attribute_role(abac_attribute_t *attr, char *keyid, char *role);
+
+// add a linking role subject
+int abac_attribute_linking_role(abac_attribute_t *attr, char *keyid, char *role, char *linked);
+
+// create the attribute cert once all the subjects have been added
+// can return 0 if there are no subjects or there's a problem building the cert
+int abac_attribute_bake(abac_attribute_t *attr);
+
+// returns true iff the cert's been baked
+int abac_attribute_baked(abac_attribute_t *attr);
+
+// write the cert to a file. returns 0 if the cert hasn't been baked
+int abac_attribute_write(abac_attribute_t *attr, FILE *out);
+
+// get chunked cert
+// returns 0 if the cert isn't baked
+int abac_attribute_cert_chunk(abac_attribute_t *, abac_chunk_t *);
+
+// destroy the cert
+void abac_attribute_free(abac_attribute_t *);
+
+// load a list of attr cert from file (aborts on fail)
+abac_list_t *abac_attribute_certs_from_file(char *);
+
+// load a list of attr cert from chunk (aborts on fail)
+abac_list_t *abac_attribute_certs_from_chunk(abac_chunk_t);
+
+// get the attribute role string
+char *abac_attribute_role_string(abac_attribute_t *attr);
+
+// get the issuer id of an attribute
+abac_id_t *abac_attribute_issuer_id(abac_attribute_t *ptr);
+
+// get the validity period of the attribute cert
+int abac_attribute_validity(abac_attribute_t *attr, struct tm *not_before, struct tm *not_after);
+
+// return the principal from an attribute's role string
+// callee must free the space
+char *abac_attribute_get_principal(abac_attribute_t *attr);
+
+// check if the attribute cert is still valid
+int abac_attribute_still_valid(abac_attribute_t *attr);
+
+
+/*
  * Error codes for loading certificates.
  */
@@ -75,4 +229,21 @@
 #define ABAC_CERT_BAD_SIG           -2  // invalid signature
 #define ABAC_CERT_MISSING_ISSUER    -3  // missing ID cert that issued the attribute cert
+#define ABAC_CERT_BAD_PRINCIPAL     -4  // Principal of attribute cert issuer has mismatch keyid
+#define ABAC_CERT_INVALID_ISSUER    -5  // Issuer of attribute cert is invalid
+#define ABAC_CERT_SIGNER_NOKEY      -6  // Signer of attribute cert is missing private key
+
+/*
+ * Error codes for IDs and Attributes
+ */
+#define ABAC_SUCCESS                          0
+#define ABAC_FAILURE                          1 /* catch all */
+#define ABAC_GENERATE_INVALID_CN             -1
+#define ABAC_GENERATE_INVALID_VALIDITY       -2
+#define ABAC_ATTRIBUTE_ISSUER_NOKEY          -3
+#define ABAC_ATTRIBUTE_INVALID_ROLE          -4
+#define ABAC_ATTRIBUTE_INVALID_VALIDITY      -5
+#define ABAC_ATTRIBUTE_INVALID_ISSUER        -6
+
+
 
 #endif /* __ABAC_H__ */
Index: libabac/abac.hh
===================================================================
--- libabac/abac.hh	(revision d4b3b529e2089c1d6789e5f0d05d99ff3aa4c533)
+++ libabac/abac.hh	(revision c75b2c28006e67279531bed747ab66b8aa312373)
@@ -2,4 +2,6 @@
 #define __ABAC_HH__
 
+#include <cstdio>
+#include <stdexcept>
 #include <string>
 #include <vector>
@@ -108,4 +110,159 @@
             abac_context_t *m_ctx;
     };
+
+    class ID {
+        public:
+            ID() : m_id(NULL) { } // do not use: required by swig
+
+            // load an ID from a file
+            ID(char *filename) : m_id(NULL) {
+                m_id = abac_id_from_file(filename);
+                if (m_id == NULL)
+                    throw std::invalid_argument("Could not load ID cert");
+            }
+
+            // load an ID from a chunk
+            ID(abac_chunk_t chunk) : m_id(NULL) {
+                m_id = abac_id_from_chunk(chunk);
+                if (m_id == NULL)
+                    throw std::invalid_argument("Could not load ID cert");
+            }
+
+            // generate an ID with a given CN and validity
+            ID(char *cn, int validity) : m_id(NULL) {
+                int ret = abac_id_generate(&m_id, cn, validity);
+                if (ret == ABAC_GENERATE_INVALID_CN)
+                    throw std::invalid_argument("CN must be alphanumeric and start with a letter");
+                if (ret == ABAC_GENERATE_INVALID_VALIDITY)
+                    throw std::invalid_argument("Validity must be > 0 days");
+            }
+
+            ID(const ID &id) { m_id = abac_id_dup(id.m_id); }
+
+            ~ID() { abac_id_free(m_id); }
+
+            // load private key from a file
+            void load_privkey(char *filename) {
+                int ret = abac_id_privkey_from_file(m_id, filename);
+                if (!ret)
+                    throw std::invalid_argument("Could not load private key");
+            }
+
+            char *keyid() { return abac_id_keyid(m_id); }
+            char *cert_filename() { return abac_id_cert_filename(m_id); }
+            void write_cert(std::FILE *out) { abac_id_write_cert(m_id, out); }
+            void write_cert(const std::string &name) {
+                std::FILE *out = fopen(name.c_str(), "w");
+                if (out == NULL)
+                    throw std::invalid_argument("Could not open cert file for writing");
+                write_cert(out);
+                fclose(out);
+            }
+            // Simplifies access from swig
+            void write_cert(const char *n) {
+                write_cert(std::string(n));
+            }
+            char *privkey_filename() { return abac_id_privkey_filename(m_id); }
+
+            // write the private ket
+            // throws a std::logic_error if no private key is loaded
+            void write_privkey(std::FILE *out) {
+                int ret = abac_id_write_privkey(m_id, out);
+                if (!ret) throw std::logic_error("No private key loaded");
+            }
+            void write_privkey(const std::string &name) {
+                std::FILE *out = fopen(name.c_str(), "w");
+                if (out == NULL)
+                    throw std::invalid_argument("Could not open privkey file for writing");
+                write_privkey(out);
+                fclose(out);
+            }
+            // Simplifies access from swig
+            void write_privkey(const char *name) {
+                write_privkey(std::string(name));
+            }
+
+            abac_chunk_t cert_chunk() { return abac_id_cert_chunk(m_id); }
+
+            friend class Attribute;
+
+        private:
+            abac_id_t *m_id;
+    };
+
+    class Attribute {
+        public:
+            Attribute() : m_attr(NULL) { } // do not use: required by swig
+
+            // create a cert
+            Attribute(ID &issuer, char *role, int validity) : m_attr(NULL) {
+                int ret = abac_attribute_create(&m_attr, issuer.m_id, role, validity);
+                if (ret == ABAC_ATTRIBUTE_ISSUER_NOKEY)
+                    throw std::invalid_argument("Issuer has no private key");
+                if (ret == ABAC_ATTRIBUTE_INVALID_ROLE)
+                    throw std::invalid_argument("Role name must be alphanumeric");
+                if (ret == ABAC_ATTRIBUTE_INVALID_VALIDITY)
+                    throw std::invalid_argument("Validity must be > 0 days");
+                if (ret == ABAC_ATTRIBUTE_INVALID_ISSUER)
+                    throw std::invalid_argument("Issuer's validity expired");
+            }
+
+            ~Attribute() { abac_attribute_free(m_attr); }
+
+            // these return false if there's a bad keyid or role name
+            // they'll throw a std::logic_error if the cert's been baked
+            bool principal(char *keyid) {
+                if (baked()) throw std::logic_error("Cert is already baked");
+                return abac_attribute_principal(m_attr, keyid);
+            }
+            bool role(char *keyid, char *role) {
+                if (baked()) throw std::logic_error("Cert is already baked");
+                return abac_attribute_role(m_attr, keyid, role);
+            }
+            bool linking_role(char *keyid, char *role, char *linked) {
+                if (baked()) throw std::logic_error("Cert is already baked");
+                return abac_attribute_linking_role(m_attr, keyid, role, linked);
+            }
+
+            // returns false if there are no subjects or libstrongswan fails
+            // throws a std::logic_error if the cert's already been baked
+            bool bake() {
+                if (baked()) throw std::logic_error("Cert is already baked");
+                return abac_attribute_bake(m_attr);
+            }
+
+            // returns true iff the cert's been baked
+            bool baked() { return abac_attribute_baked(m_attr); }
+
+            // throws a std::logic_error if the cert isn't baked
+            void write(std::FILE *out) {
+                int ret = abac_attribute_write(m_attr, out);
+                if (!ret) throw std::logic_error("Cert is not baked");
+            }
+
+            void write(const std::string &name) {
+                std::FILE *out = fopen(name.c_str(), "w");
+                if (out == NULL)
+                    throw std::invalid_argument("Could not open cert file for writing");
+                write(out);
+                fclose(out);
+            }
+
+            // Simplifies access from swig
+            void write(const char *name) {
+                write(std::string(name));
+            }
+
+            // throws a std::logic_error if the cert isn't baked
+            abac_chunk_t cert_chunk() {
+                abac_chunk_t ret;
+                if (!baked()) throw std::logic_error("Cert is not baked");
+                abac_attribute_cert_chunk(m_attr, &ret);
+                return ret;
+            }
+
+        private:
+            abac_attribute_t *m_attr;
+    };
 }
 
Index: libabac/abac_attribute.c
===================================================================
--- libabac/abac_attribute.c	(revision c75b2c28006e67279531bed747ab66b8aa312373)
+++ libabac/abac_attribute.c	(revision c75b2c28006e67279531bed747ab66b8aa312373)
@@ -0,0 +1,418 @@
+
+/* abac_attribute.c */
+
+#define _GNU_SOURCE
+#include <stdio.h>
+#include <assert.h>
+#include <ctype.h>
+#include <string.h>
+#include <time.h>
+
+#include "libabac_common.h"
+#include "abac_util.h"
+#include "abac_xml.h"
+
+#define ROLE_SEPARATOR " <- "
+#define INTERSECTION_SEP " & "
+#define SHA1_LENGTH 40
+
+static int debug=0;
+
+// a GENI XML attribute chunk might contain multiple 
+// attribute rules. It will be translate into multiple
+// abac_attribute structures but with cert ptr pointing
+// to the same xml chunk
+// issuer can be missing but then it won't be bakable
+// unless it is baked just for creddy's roles call
+struct _abac_attribute_t {
+    abac_id_t *issuer_id; 
+    char *role;
+    long validity;
+
+    char *head_string;
+    char *tail_string;
+
+    abac_chunk_t cert; // the XML chunk
+};
+
+char *abac_attribute_role_string(abac_attribute_t *attr);
+extern abac_id_t *abac_verifier_lookup_id(char *keyid);
+static char *_validate_principal(char *keyid);
+
+/************************************************************/
+abac_chunk_t abac_attribute_cert(abac_attribute_t *ptr)
+{
+    assert(ptr);
+    return ptr->cert;
+}
+
+abac_id_t *abac_attribute_issuer_id(abac_attribute_t *ptr)
+{
+    assert(ptr);
+    return ptr->issuer_id;
+}
+
+// validity is measured in seconds (as of 0.2.0)
+// Acme.customer
+int abac_attribute_create(abac_attribute_t **ret, abac_id_t *issuer_id, char *role, long validity) {
+    if (!abac_id_has_privkey(issuer_id))
+        return ABAC_ATTRIBUTE_ISSUER_NOKEY;
+    if (!abac_clean_name(role))
+        return ABAC_ATTRIBUTE_INVALID_ROLE;
+    if (validity < 0)
+        return ABAC_ATTRIBUTE_INVALID_VALIDITY;
+    if (!abac_id_still_valid(issuer_id))
+        return ABAC_ATTRIBUTE_INVALID_ISSUER;
+
+    abac_attribute_t *attr = abac_xmalloc(sizeof(abac_attribute_t));
+    if(issuer_id) attr->issuer_id = abac_id_dup(issuer_id);
+        else attr->issuer_id = NULL;
+    attr->role = abac_xstrdup(role);
+    attr->validity = validity;
+
+    attr->head_string = NULL;
+    attr->tail_string = NULL;
+
+    // NULL until baked
+    attr->cert.ptr=NULL;
+    attr->cert.len=0;
+
+    *ret = attr;
+    return ABAC_SUCCESS;
+}
+
+/**
+ * Get the validity period.(xml module returns the diff from expire time - now()
+ */
+int abac_attribute_validity(abac_attribute_t *attr,struct tm *not_before,struct tm *not_after) {
+    assert(attr);
+    memset(not_before, 0, sizeof(struct tm));
+    memset(not_after, 0, sizeof(struct tm));
+
+    time_t now;
+    time(&now);
+    gmtime_r(&now, not_before);
+    char *xml=attr->cert.ptr;
+    long validity=get_validity_from_xml(xml);
+
+    time_t etime = now + validity;
+    gmtime_r(&etime, not_after);
+
+    fprintf(stderr,"validity from the xml blob is %ld\n",validity);
+    if(validity == 0)
+        return ABAC_FAILURE;
+    return ABAC_SUCCESS;
+}
+
+int abac_attribute_still_valid(abac_attribute_t *attr)
+{
+    assert(attr);
+    assert(attr->cert.ptr);
+    long v=get_validity_from_xml(attr->cert.ptr);
+    if (v > 0.0)
+        return 1;
+    else return 0;
+}
+
+void abac_attribute_set_head(abac_attribute_t *attr, char *string)
+{
+    assert(attr);
+    attr->head_string=string;
+}
+
+char *abac_attribute_get_head(abac_attribute_t *attr)
+{
+    assert(attr);
+    return attr->head_string;
+}
+
+void abac_attribute_set_tail(abac_attribute_t *attr, char *string)
+{
+    assert(attr);
+    attr->tail_string=string;
+}
+
+char *abac_attribute_get_tail(abac_attribute_t *attr)
+{
+    assert(attr);
+    return attr->tail_string;
+}
+
+/* A.b->C, return copy of a A */
+char *abac_attribute_get_principal(abac_attribute_t *attr)
+{
+    char *role_string=abac_attribute_role_string(attr);
+    /* make an copy */
+    char *tmp=strdup(role_string);
+    char *head_tail[2];
+    int ret;
+    abac_split(tmp, "<-", head_tail, &ret);
+    if (ret != 2) goto err;
+    abac_split(head_tail[0], ".", head_tail, &ret);
+    if (ret != 2) goto err;
+    char *prin=strdup(head_tail[0]);
+    free(tmp);
+    return prin;
+
+err:     
+     free(tmp);
+     return NULL;
+}
+
+int abac_attribute_principal(abac_attribute_t *attr, char *keyid) {
+    char *copy = _validate_principal(keyid);
+    if (copy == NULL)
+        return 0;
+
+    abac_attribute_set_tail(attr,copy);
+    return 1;
+}
+
+int abac_attribute_role(abac_attribute_t *attr, char *keyid, char *role) {
+    if (!abac_clean_name(role))
+        return 0;
+
+    char *copy = _validate_principal(keyid);
+    if (copy == NULL)
+        return 0;
+
+    int len = strlen(copy) + strlen(role) + strlen(ROLE_SEPARATOR) + 1;
+    copy = abac_xrealloc(copy, len);
+    strcat(copy, ".");
+    strcat(copy, role);
+
+    abac_attribute_set_tail(attr,copy);
+    return 1;
+}
+
+int abac_attribute_linking_role(abac_attribute_t *attr, char *keyid, char *role, char *linked) {
+    if (!abac_clean_name(role) || !abac_clean_name(linked))
+        return 0;
+
+    char *copy = _validate_principal(keyid);
+    if (copy == NULL)
+        return 0;
+
+    int len = strlen(copy) + strlen(role) + strlen(linked) + strlen(ROLE_SEPARATOR) + 2;
+    copy = abac_xrealloc(copy, len);
+    strcat(copy, ".");
+    strcat(copy, role);
+    strcat(copy, ".");
+    strcat(copy, linked);
+
+    abac_attribute_set_tail(attr,copy);
+    return 1;
+}
+
+
+
+// 0 for fail to bake, 1 is baked okay
+int abac_attribute_bake(abac_attribute_t *attr) {
+    assert(attr);
+    assert(attr->head_string);
+    assert(attr->tail_string);
+
+    abac_chunk_t id_chunk = { NULL, 0 };
+    int ret=abac_id_PEM(attr->issuer_id, &id_chunk);
+    if(ret != ABAC_CERT_SUCCESS)
+        return 0; 
+
+    char *role_string = abac_attribute_role_string(attr);
+
+/* Make an new GENI abac credential with the rt0 rule that expires secs from
+ * now.  cert is the PEM encoded X.509 of the issuer's certificate as a string.
+ * certlen is the length of cert.  Returns the XML. Caller is responsible for
+ * freeing it. */
+    char *attr_cert=my_make_credential(role_string, attr->validity, id_chunk.ptr, id_chunk.len);
+
+    if (attr_cert == NULL)
+        return 0;
+
+    attr->cert.ptr = (unsigned char *)attr_cert;
+    attr->cert.len = strlen(attr_cert);
+
+    free(role_string);
+    return 1;
+}
+
+// make an explicit copy
+int abac_attribute_cert_chunk(abac_attribute_t *attr, abac_chunk_t *chunk) {
+
+    chunk->ptr=NULL;
+    chunk->len=0;
+
+    if (attr->cert.ptr == NULL)
+        return 0;
+
+    /* return the xml chunk */
+    chunk->ptr= (unsigned char *)abac_xstrdup((char *)attr->cert.ptr);
+    chunk->len=attr->cert.len;
+    return chunk->len;
+}
+
+int abac_attribute_baked(abac_attribute_t *attr) {
+    return (attr->cert.ptr != NULL);
+}
+
+
+static abac_attribute_t *_load_attr(char *role_string, char *xml)
+{
+
+if(debug) fprintf(stderr,"loading -> %s \n", role_string);
+
+    char *head_tail[2];
+    int ret;
+    abac_split(role_string, "<-", head_tail, &ret);
+    if (ret != 2) return NULL; 
+
+    char *keyid=get_keyid_from_xml(xml);
+    abac_id_t *issuer_id=abac_verifier_lookup_id(keyid);
+
+    long validity=get_validity_from_xml(xml);
+    
+    abac_attribute_t *attr = abac_xmalloc(sizeof(abac_attribute_t));
+    if(issuer_id)
+        attr->issuer_id = abac_id_dup(issuer_id);
+        else attr->issuer_id=NULL;
+    attr->validity = validity;
+
+    attr->head_string = abac_xstrdup(head_tail[0]);
+    attr->tail_string = abac_xstrdup(head_tail[1]);
+    char *tmp=strstr(attr->head_string,".");
+    attr->role =abac_xstrdup(tmp+1);
+
+    attr->cert.ptr=(unsigned char *)xml;
+    attr->cert.len=strlen(xml);
+
+    return attr;
+}
+
+abac_list_t *abac_attribute_certs_from_file(char *filename)
+{
+    abac_list_t *alist=abac_list_new();
+    char *xml=NULL;
+    char *rt0=NULL;
+
+    char **rt0s=my_read_credential(filename, &xml);
+    if(xml == NULL) return alist;
+
+    int len=strlen(xml);
+    if(len==0) return alist;
+
+    abac_attribute_t *attr;
+
+    int i=0;
+    do {
+        rt0 = rt0s[i]; 
+        if(rt0 == NULL) break;
+        attr=_load_attr(rt0, xml);
+        if(attr)
+            abac_list_add(alist, attr);
+        free(rt0);
+        i++;
+    } while (rt0s[i] !=NULL);
+
+    free(rt0s);
+    free(xml);
+
+    return alist;
+}
+
+abac_list_t *abac_attribute_certs_from_chunk(abac_chunk_t chunk) {
+
+    abac_list_t *alist=abac_list_new();
+    char *xml=(char *)chunk.ptr;
+    char **rt0s=get_rt0_from_xml(xml);
+    char *rt0=NULL;
+    int len=strlen(xml);
+    if(len==0) return alist;
+
+    abac_attribute_t *attr;
+    int i=0;
+    do {
+        rt0 = rt0s[i]; 
+        if(rt0 == NULL) break;
+        attr=_load_attr(rt0, xml);
+        if(attr)
+            abac_list_add(alist, attr);
+        free(rt0);
+        i++;
+    } while (rt0s[i] !=NULL);
+
+    free(rt0s);
+    return alist;
+}
+
+// returns 0 if the cert hasn't been baked
+int abac_attribute_write(abac_attribute_t *attr, FILE *out) {
+    assert(attr != NULL);
+
+    if (attr->cert.ptr == NULL)
+        return 0;
+
+    // write to file
+    fwrite(attr->cert.ptr, attr->cert.len, 1, out);
+
+    return 1;
+}
+
+void abac_attribute_free(abac_attribute_t *attr) {
+
+if(debug) fprintf(stderr,"calling abac_attribute_free on %s\n", attr->head_string);
+
+    if (attr == NULL)
+        return;
+
+    if(attr->issuer_id) abac_id_free(attr->issuer_id);
+
+    free(attr->role);
+    free(attr->head_string);
+    free(attr->tail_string);
+
+/* XXX this can not be free as if it is a char string
+    free(attr->cert.ptr);
+*/
+
+    free(attr);
+}
+
+//
+// Helper functions below
+//
+
+// validate a princpal's name
+// makes sure it's a valid SHA1 identifier
+// return values:
+//  success: malloc'd copy with all hex digits lowercase
+//  fail: NULL
+static char *_validate_principal(char *keyid) {
+    int i;
+    char *copy = NULL;
+
+    if (strlen(keyid) != SHA1_LENGTH)
+        return NULL;
+
+    copy = abac_xstrdup(keyid);
+    for (i = 0; i < SHA1_LENGTH; ++i) {
+        copy[i] = tolower(copy[i]);
+        if (!isxdigit(copy[i]))
+            goto error;
+    }
+
+    return copy;
+
+error:
+    free(copy);
+    return NULL;
+}
+
+// combine up the attribute's rule string, explicit copy
+char *abac_attribute_role_string(abac_attribute_t *attr) {
+    assert(attr);
+
+    char *role_string=NULL;
+    asprintf(&role_string,"%s<-%s",attr->head_string,attr->tail_string);
+    return role_string;
+}
+
+
